"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.createDevTools = exports.setDevTools = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fallback = function fallback(env) {
  return {
    connect: function connect() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      env && console.warn("No DevTools. Failed to connect with: ", args);
      return {
        send: function send() {
          for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
          }

          return env && console.warn("No DevTools. Failed to send: ", args);
        }
      };
    }
  };
};

var setDevTools = function setDevTools(env) {
  var maybeExtension = env && typeof window !== "undefined" && window.__REDUX_DEVTOOLS_EXTENSION__;
  return maybeExtension || fallback(env);
};

exports.setDevTools = setDevTools;
var defaults = {
  env: true,
  name: "Your App"
};
/**
 *
 * @param {Object} options optional configurations
 * these are whether or not you wish to use the middleware, for example
 * this flag could be true in development but false for production
 * You can also specify a name to display in the Redux Dev Tools
 *
 * @return redux middleware
 */

var createDevTools = function createDevTools() {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var config = _objectSpread({}, defaults, {}, options);

  var extension = setDevTools(config.env);
  var devTools = extension.connect({
    name: config.name
  });
  return function (store) {
    return function (next) {
      return function (action) {
        var ret = next(action);
        devTools.send(action.type, store.getState());
        return ret;
      };
    };
  };
};

exports.createDevTools = createDevTools;
var _default = createDevTools;
exports["default"] = _default;